## ros-indigo-opencv-candidate 0.2.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(opencv_candidate)

find_package(catkin REQUIRED)
find_package(libg2o QUIET)
find_package(OpenCV)
find_library(DEPTH_SENSE_LIBRARIES DepthSense /opt/DepthSenseSDK/lib)

if (${DEPTH_SENSE_LIBRARIES} STREQUAL DEPTH_SENSE_LIBRARIES-NOTFOUND)
  set(OPENCV_CREATIVE "")
else()
  set(OPENCV_CREATIVE opencv_creative)
endif()

if (libg2o_FOUND)
  set(EXTRA_DEPENDS libg2o)
  set(EXTRA_LIBRARIES opencv_candidate_reconst3d)
endif()
catkin_package(DEPENDS OpenCV ${EXTRA_DEPENDS}
               INCLUDE_DIRS include
               LIBRARIES opencv_candidate
                         ${OPENCV_CREATIVE}
                         opencv_rgbd
                         ${opencv_candidate_reconst3d}
)

find_package(OpenCV REQUIRED core imgproc highgui calib3d)
message(STATUS "OpenCV version: ${OpenCV_VERSION}")
message(STATUS "OpenCV headers: ${OpenCV_INCLUDE_DIRS}")
include_directories(SYSTEM ${OpenCV_INCLUDE_DIRS})
include_directories(include)

# install the include directory
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/rgbd/include)

install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/opencv_candidate
        DESTINATION include
        COMPONENT main
)

add_subdirectory(src)

=== src/CMakeLists.txt ===
add_subdirectory(opencv_candidate)
add_subdirectory(reconst3d)
add_subdirectory(rgbd)

find_library(DEPTH_SENSE_LIBRARIES DepthSense /opt/DepthSenseSDK/lib)

if (NOT ${DEPTH_SENSE_LIBRARIES} STREQUAL DEPTH_SENSE_LIBRARIES-NOTFOUND)
  add_subdirectory(creative)
endif()

=== src/creative/CMakeLists.txt ===
find_package(Boost REQUIRED thread system)

include_directories(SYSTEM /opt/DepthSenseSDK/include
                           ${OpenCV_INCLUDE_DIRS}
                           ${BOOST_INCLUDE_DIRS}
)

find_library(DEPTH_SENSE_LIBRARIES DepthSense /opt/DepthSenseSDK/lib)
find_library(TURBO_JPEG_LIBRARIES turbojpeg /opt/DepthSenseSDK/lib)


add_library(opencv_creative SHARED creative.cpp)

target_link_libraries(opencv_creative ${Boost_LIBRARIES}
                                      ${OpenCV_LIBRARIES}
                                      ${DEPTH_SENSE_LIBRARIES}
                                      ${TURBO_JPEG_LIBRARIES}
)

install(TARGETS opencv_creative
        DESTINATION lib
)

add_executable(main main.cpp)
target_link_libraries(main opencv_creative
)

=== src/rgbd/CMakeLists.txt ===
# merge some RGBD functions into a module
#set(the_description "a set of RGBD functions")
#ocv_define_module(rgbd)

find_package(OpenCV REQUIRED)
if (OpenCV_VERSION VERSION_EQUAL "3")
  return()
endif()

add_library(opencv_rgbd src/normal.cpp
                        src/depth_to_3d.cpp
                        src/depth_cleaner.cpp
                        src/odometry.cpp
                        src/plane.cpp
                        src/rgbd_init.cpp
                        src/utils.cpp
)

target_link_libraries(opencv_rgbd ${OpenCV_LIBS}
                                  ${OpenCV_LIBRARIES}
)

install(TARGETS opencv_rgbd
        DESTINATION lib
)

install(DIRECTORY include/opencv2/rgbd
        DESTINATION include/opencv2
        COMPONENT main
)

# Add sample
add_executable(odometry_evaluation samples/odometry_evaluation.cpp)
target_link_libraries(odometry_evaluation ${OpenCV_LIBRARIES} opencv_rgbd)

# Add some tests
return()
add_executable(rgbd_tests test/test_main.cpp
                          test/test_normal.cpp
                          test/test_odometry.cpp
                          test/test_precomp.cpp
                          test/test_utils.cpp
)

find_library(OPENCV_TS_LIBRARY opencv_ts ${OpenCV_LIB_DIR})
target_link_libraries(rgbd_tests ${OpenCV_LIBRARIES}
                                 opencv_rgbd
                                 ${OPENCV_TS_LIBRARY}
)

add_test(rgbd_tests rgbd_tests)

=== debian/changelog ===
ros-indigo-opencv-candidate (0.2.4-0trusty) trusty; urgency=high

  * get features2d to compile with OpenCV3
  * do not compile RGBD for OpenCV3 as there should be an opencv_contrib module anyway
  * remove Python bindings of data matrix
  * remove LSH as it is now upstream
  * get datamatrix to compile with OpenCV3
  * Updating namespaces
  * Contributors: Vincent Rabaud, edgarriba

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 28 Mar 2015 23:00:00 -0000

ros-indigo-opencv-candidate (0.2.3-0trusty) trusty; urgency=high

  * no need for CMake hacks (plus, cholmod is not needed anymore)
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 19 Jul 2014 22:00:00 -0000

ros-indigo-opencv-candidate (0.2.2-0trusty) trusty; urgency=high

  * do not build reconst3d as it is not used anywhere
    It's also a way to remove a package that depends on g2o for less maintenance
  * update url and maintainer's email address
  * add basic docs
  * compile under trusty
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 18 Jul 2014 22:00:00 -0000

ros-indigo-opencv-candidate (0.2.1-0trusty) trusty; urgency=high

  * get distro agnostic OpenCv2 dependency
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vrabaud@willowgarage.com>  Sat, 12 Apr 2014 22:00:00 -0000

ros-indigo-opencv-candidate (0.2.0-0trusty) trusty; urgency=high

  * disable tests as the Ubuntu version of OpenCV has a bug with TS for now (cvconfig.h not present)
  * drop Fuerte support
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vrabaud@willowgarage.com>  Sat, 12 Apr 2014 22:00:00 -0000

ros-indigo-opencv-candidate (0.1.9-0trusty) trusty; urgency=high

  * fix dependencies with PCL

 -- Vincent Rabaud <vrabaud@willowgarage.com>  Wed, 28 Aug 2013 21:14:21 +0200

=== debian/control ===
Source: ros-indigo-opencv-candidate
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-cv-bridge
Homepage: https://github.com/wg-perception/opencv_candidate
Standards-Version: 3.9.2

Package: ros-indigo-opencv-candidate
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-cv-bridge
Description: Experimental OpenCV functions

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-opencv-candidate//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
